#include "WINSOCK2.h"

#pragma comment(lib, "wsock32.lib")
#pragma comment(lib, "ws2_32.lib")

//==============================Data type definition==============================
typedef int apiReturn;   //function return value type
//==============================frequent data definition=============================
#define	ID_MAX_SIZE_64BIT	8		//capacity of tag ID No. is 64bit
#define ID_MAX_SIZE_96BIT	65		//Id no. of  tag
#define MAX_LABELS			100		// reading/written info less than 100 tags at the same time

//==============================API function return data==============================
#define	_OK					0x00	// operation success

//error in communication 
#define _init_rs232_err		0x81	//  Communication interface initialization failed
#define _no_scanner			0x82	//  can not find reader
#define _comm_error         0x83	//  wrong of receive and send info
#define _baudrate_error     0x84	//  wrong in seting baud frequency
#define _init_net_error		0x85	//  RJ45 interface initialization failed
#define _net_error          0x86	// RJ45 interface transceiver communication data error

// return info by reader
#define _no_antenna			0x01   //antenna connect failed
#define _no_label			0x02   //not checked tag
#define _invalid_label		0x03   //invalid tag
#define _less_power			0x04   //reading/writing power less
#define _write_prot_error	0x05   //protect in this sector
#define _check_sum_error	0x06   //check and wrong
#define _parameter_error	0x07   //wrong in parameter
#define _memory_error		0x08   //data sector is not exist
#define _password_error		0x09   //wrong password
#define _killpassword_error	0x0a   //G2 tag destroyed and password is zero
#define _nonlicet_command	0x0b   //invalid demand
#define _nonlicet_user		0x0c   //invalid user with not- matched password
#define _invalid_command	0x1e   //invalid demand such as parameter
#define _other_error		0x1f   //unknown demand

//wrong input function
#define _no_cardID_input   0x20   //other error

typedef struct tagReaderDate
{
	BYTE	Year;			//year
	BYTE	Month;			//month
	BYTE	Day;			//day
	BYTE	Hour;			//hour
	BYTE	Minute;			//minute
	BYTE	Second;			//second
}ReaderDate;


typedef struct tagReader2200Param
{
	BYTE	BaudRate;			//bunch communication speeddata00H~08Hsppeed is according to baud rate demand
	BYTE	Power;				//send power data, data30~160
	BYTE	Min_Frequence;		//send microwave frequency incept,data 1~63
	BYTE	Antenna;			//antenna choice,1-ant1,2-ant2,4-ant4,8-ant8
	BYTE	WorkMode;			//operation method of reader1-timing2-touching3-demand4-set-time 25touch 2 
	BYTE	ReadInterval;		//interval of reading  0-10ms, 1-30ms, 2-50ms
	BYTE	OutMode;			//output method(direct output ,standard output)
	BYTE	TriggerMode;	    //touch method
	BYTE	IDPosition;			//address of card no. in tag
	BYTE	IfTestValidity;		//if tag is invalid
	BYTE	OutInterface;		//format and interface of outputing card no.(Wiegan26,Wiegan34,RS485,RS232,RJ45)
	BYTE	NumofCard;			//no. of reading card at most
	BYTE	Power2;				//send power 2 data30~160
	BYTE	TagType;			//type of tag01HISO18000-6B02HEPCC104HEPCC1G208HTK900
	BYTE	WiegandWidth;		//Weigandimpulse data
	BYTE	WiegandInterval;	//Weigand interval data of impulse
	BYTE	ID_Start;			//start bot of output card no., data 04
	BYTE	Max_Frequence;		//the end point of outputing micro-wave. data 1~63
	BYTE	ReadDuration;		//reading duration timeRF duration timeONLY FORTK900010ms120ms230ms340ms
	BYTE	StandardTime;		//interval time of standard outputing,data20second1255
	BYTE	EnableBuzzer;		//1:buzzer0:no buzzer
	BYTE	ReaderAddress;		//0-255
	BYTE	HostIP1;			//PC IP 1
	BYTE	HostIP2;			///PC IP2
	BYTE	HostIP3;			///PC IP3
	BYTE	HostIP4;			///PC IP4
	BYTE	HostPort1;			/PC ports1
	BYTE	HostPort2;			//PC ports2
	BYTE	Reserve29;			//keep 
	BYTE	Reserve30;			//keep
	BYTE	TX_Mode;			//sending mode:0-send and receive mode 1-RF mode
	BYTE	Modulation;			//set0-confetion singal1-confetion singal
} Reader1000Param;

typedef struct tagReaderDebugState
{
	BYTE	Test;				//0operation status1debug status
	BYTE	Reserve2;			//keep
	BYTE	Reserve3;			//keep
	BYTE	Reserve4;			//keep
} ReaderDebugState;

//==============================function definition==============================

//connect reader
apiReturn _stdcall ConnectScanner(HANDLE *hScanner, char *szPort, int nBaudRate);

//disconnect reader
apiReturn _stdcall DisconnectScanner(HANDLE hScanner);

//==============================device control demand==============================
//set baud rate
apiReturn _stdcall SetBaudRate(HANDLE hScanner, int nBaudRate,int Address);

//reader edition no.
apiReturn _stdcall GetReaderVersion(HANDLE hScanner, WORD *wHardVer, WORD  *wSoftVer,int Address);

//seting reader relay status
apiReturn _stdcall SetRelay(HANDLE hScanner, int Relay,int Address);

//set output rate
apiReturn _stdcall SetOutputPower(HANDLE hScanner, int nPower1,int Address);

//set operation rate
apiReturn _stdcall SetFrequency(HANDLE hScanner, int Min_Frequency, int Max_Frequency,int Address);

//operation pameter of reader
apiReturn _stdcall ReadParam(HANDLE hScanner, Reader1000Param * pParam,int Address);

//operation pameter of reader
apiReturn _stdcall WriteParam(HANDLE hScanner, Reader1000Param * pParam,int Address);

//operation out-factory pameter of reader
apiReturn _stdcall ReadFactoryParameter(HANDLE hScanner);

//choose antenna
apiReturn _stdcall SetAntenna(HANDLE hScanner, int Antenna,int Address);

//reposition reader
apiReturn _stdcall Reboot(HANDLE hScanner,int Address);

//set time
apiReturn _stdcall SetReaderTime(HANDLE hScanner, ReaderDate time,int Address);

//get time
apiReturn _stdcall GetReaderTime(HANDLE hScanner, ReaderDate *time,int Address);

//add list
apiReturn _stdcall AddLableID(HANDLE hScanner, int listlen, int datalen, BYTE * data);

//delete list
apiReturn _stdcall DelLableID(HANDLE hScanner, int listlen, int datalen, BYTE * data);

//get list
apiReturn _stdcall GetLableID(HANDLE hScanner, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//get record
apiReturn _stdcall GetRecord(HANDLE hScanner, ReaderDate *stime, ReaderDate *etime, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//delete all record
apiReturn _stdcall DeleteAllRecord(HANDLE hScanner);

//==============================network demand==============================
//set IP address of reader
apiReturn _stdcall SetReaderNetwork(HANDLE hScanner, BYTE IP_Address[4], int Port, BYTE Mask[4], BYTE Gateway[4]);

//get  IP address of reader
apiReturn _stdcall GetReaderNetwork(HANDLE hScanner, BYTE *IP_Address, int *Port, BYTE *Mask, BYTE *Gateway);

//ste MAC address of reader
apiReturn _stdcall SetReaderMAC(HANDLE hScanner, BYTE MAC[6]);

//get MAC  address of reader
apiReturn _stdcall GetReaderMAC(HANDLE hScanner, BYTE *MAC);

//==============================ISO-6B data reading and writing demand==============================
//check tag exist
apiReturn _stdcall ISO6B_LabelPresent(HANDLE hScanner, int *nCounter,int Address);

//get ISO6B ID no. of tag
apiReturn _stdcall ISO6B_ReadLabelID(HANDLE hScanner, BYTE *IDBuffer, int *nCounter,int Address);

//list special tag
apiReturn _stdcall ISO6B_ListSelectedID(HANDLE hScanner, int Cmd, int ptr, BYTE Mask, BYTE *Data, BYTE *IDBuffer, int *nCounter,int Address);

/read data 
apiReturn _stdcall ISO6B_ReadByteBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data,int Address);

//write 4 bits once
apiReturn _stdcall ISO6B_WriteByteBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data,int Address);

//write 1 bits once
apiReturn _stdcall ISO6B_WriteAByte(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data,int Address);

//write big bytebyte more than 16
apiReturn _stdcall ISO6B_WriteLongBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data,int Address);

//set protect status
apiReturn _stdcall ISO6B_WriteProtect(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr,int Address);

//reading and written  protect status
apiReturn _stdcall ISO6B_ReadWriteProtect(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE *Protected,int Address);

//all delete
apiReturn _stdcall ISO6B_ClearMemory(HANDLE hScanner, BYTE CardType, BYTE *IDBuffer,int Address);

//get ID no. of reader
apiReturn _stdcall GetReaderID(HANDLE hScanner, BYTE *ReaderID);

//==============================EPC C1G2date reading and writing demand=============================
//get EPC1G2 ID no. of tag
apiReturn _stdcall EPC1G2_ReadLabelID(HANDLE hScanner, BYTE mem, int ptr, BYTE len, BYTE *mask, BYTE *IDBuffer, int *nCounter,int Address);

//read data
apiReturn _stdcall EPC1G2_ReadWordBlock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword,int Address);

//write data
apiReturn _stdcall EPC1G2_WriteWordBlock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword,int Address);

//set status of reading and writing
apiReturn _stdcall EPC1G2_SetLock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE Lock, BYTE *AccessPassword,int Address);

//delete tag data
apiReturn _stdcall EPC1G2_EraseBlock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len,int Address);

//dormancy tag
apiReturn _stdcall EPC1G2_KillTag(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE *KillPassword,int Address);

//write EPC
apiReturn _stdcall EPC1G2_WriteEPC(HANDLE hScanner, BYTE len, BYTE *Data, BYTE *AccessPassword,int Address);

//sector loct demand
apiReturn _stdcall EPC1G2_BlockLock(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE ptr, BYTE *AccessPassword,int Address);

//EAS status operation demand
apiReturn _stdcall EPC1G2_ChangeEas(HANDLE hScanner, BYTE EPC_WORD, BYTE *IDBuffer, BYTE State, BYTE *AccessPassword,int Address);

//EAS alarm demand
apiReturn _stdcall EPC1G2_EasAlarm(HANDLE hScanner,int Address);

//pretect seting
apiReturn _stdcall EPC1G2_ReadProtect(HANDLE hScanner,BYTE *AccessPassword, BYTE EPC_WORD, BYTE *IDBuffer,int Address);

//reposition pretect seting
apiReturn _stdcall EPC1G2_RStreadProtect(HANDLE hScanner, BYTE *AccessPassword,int Address);

//frequency chart pretect
apiReturn _stdcall EPC1G2_Calibrate(HANDLE hScanner, BYTE *AccessPassword, BYTE Kword);

//check tag
apiReturn _stdcall EPC1G2_DetectTag(HANDLE hScanner,int Address);
//==============================TK900 data reading and writing demand==============================
//read TK900 ID no. of tag
apiReturn _stdcall TK900_ReadLabelID(HANDLE hScanner, BYTE *IDBuffer, int *nCounter,int Address);

//read data 
apiReturn _stdcall TK900_ReadPageBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data,int Address);

//write data
apiReturn _stdcall TK900_WritePageBlock(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE *Data,int Address);

//set reading  protect status
apiReturn _stdcall TK900_SetProtect(HANDLE hScanner, BYTE *IDBuffer, BYTE ptr, BYTE len,int Address);

//set writing protect status
apiReturn _stdcall TK900_GetProtect(HANDLE hScanner, BYTE *IDBuffer ,BYTE *state,int Address);

//set tag into TTO status
apiReturn _stdcall TK900_SetTTO(HANDLE hScanner, BYTE *IDBuffer ,BYTE ptr, BYTE len,int Address);

//read TTOtag 
apiReturn _stdcall TK900_ListTagPage(HANDLE hScanner, BYTE *IDBuffer ,BYTE *Data,int Address);

//get TTO address and length of tag
apiReturn _stdcall TK900_GetTTOStartAdd(HANDLE hScanner, BYTE *IDBuffer ,BYTE *len,int Address);

//==============================net interface function definition==============================
//connect reader
apiReturn _stdcall Net_ConnectScanner(SOCKET *hSocket,char *nTargetAddress,UINT nTargetPort,char *nHostAddress,UINT nHostPort);

//disconnect reader
apiReturn _stdcall Net_DisconnectScanner();


//==============================device control demand==============================
//Set the baud rate

apiReturn _stdcall Net_SetBaudRate(SOCKET hSocket, int nBaudRate);

//Read the version number

apiReturn _stdcall Net_GetReaderVersion(SOCKET hSocket, WORD *wHardVer, WORD  *wSoftVer);

//Set the output power

apiReturn _stdcall Net_SetOutputPower(SOCKET hSocket, int nPower);

//Set operating frequency

apiReturn _stdcall Net_SetFrequency(SOCKET hSocket, int Min_Frequency, int Max_Frequency);

//Read writer working parameters

apiReturn _stdcall Net_ReadParam(SOCKET hSocket, Reader1000Param *pParam);

//Set Modulation

apiReturn _stdcall Net_SetModDepth(SOCKET hSocket, int ModDepth);

//Be modulation

apiReturn _stdcall Net_GetModDepth(SOCKET hSocket, int *ModDepth);

//Reader operating parameters set

apiReturn _stdcall Net_WriteParam(SOCKET hSocket, Reader1000Param *pParam);

//Choose antenna
apiReturn _stdcall Net_SetAntenna(SOCKET hSocket, int Antenna);

//Read reader's the factory parameters

apiReturn _stdcall Net_ReadFactoryParameter(SOCKET hSocket);

//Reset reader

apiReturn _stdcall Net_Reboot(SOCKET hSocket);

//Setting time
apiReturn _stdcall Net_SetReaderTime(SOCKET hSocket, ReaderDate time);

//Get time
apiReturn _stdcall Net_GetReaderTime(SOCKET hSocket, ReaderDate *time);

//Add list 
apiReturn _stdcall Net_AddLableID(SOCKET hSocket, int listlen, int datalen, BYTE * data);

//Delete list
apiReturn _stdcall Net_DelLableID(SOCKET hSocket, int listlen, int datalen, BYTE * data);

//Get list

apiReturn _stdcall Net_GetLableID(SOCKET hSocket, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//Get the records
apiReturn _stdcall Net_GetRecord(SOCKET hSocket, ReaderDate *stime, ReaderDate *etime, int startaddr, int listlen, int *relistlen, int *taglen, BYTE * data);

//Delete all records

apiReturn _stdcall Net_DeleteAllRecord(SOCKET hSocket);

//==============================Network command==============================
//Setting reader IP address
apiReturn _stdcall Net_SetReaderNetwork(SOCKET hSocket, BYTE IP_Address[4], int Port, BYTE Mask[4], BYTE Gateway[4]);

//Get reader IP address
apiReturn _stdcall Net_GetReaderNetwork(SOCKET hSocket, BYTE *IP_Address, int *Port, BYTE *Mask, BYTE *Gateway);

//Setting reader MAC address
apiReturn _stdcall Net_SetReaderMAC(SOCKET hSocket, BYTE MAC[6]);

//Get the reader MAC address
apiReturn _stdcall Net_GetReaderMAC(SOCKET hSocket, BYTE *MAC);

//Get the reader ID
apiReturn _stdcall Net_GetReaderID(SOCKET hSocket, BYTE *ReaderID);

//==============================IOCommands==============================
//Setting reader relay state
apiReturn _stdcall Net_SetRelay(SOCKET hSocket, int relay);

//Get reader relay state
apiReturn _stdcall Net_GetRelay(SOCKET hSocket, int *relay);

//==============================ISO-6B Read and write data command==============================
//Detection of labels there

apiReturn _stdcall Net_ISO6B_LabelPresent(SOCKET hSocket, int *nCounter);

//Read ISO6B tag IDNo.
apiReturn _stdcall Net_ISO6B_ReadLabelID(SOCKET hSocket, BYTE *IDBuffer, int *nCounter);

//Lists the selected tags

apiReturn _stdcall Net_ISO6B_ListSelectedID(SOCKET hSocket, int Cmd, int ptr, BYTE Mask, BYTE *Data, BYTE *IDBuffer, int *nCounter);

//Read a piece of data
apiReturn _stdcall Net_ISO6B_ReadByteBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data);

//To write 4 byte of data once
apiReturn _stdcall Net_ISO6B_WriteByteBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data);

//To write a byte of data once

apiReturn _stdcall Net_ISO6B_WriteAByte(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len, BYTE *Data);

//Set write-protected

apiReturn _stdcall Net_ISO6B_WriteProtect(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr);

//Write and read protected mode
apiReturn _stdcall Net_ISO6B_ReadWriteProtect(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE *Protected);

//==============================EPC C1G2 Read and write data command==============================
//Read EPC1G2 tag ID No.
apiReturn _stdcall Net_EPC1G2_ReadLabelID(SOCKET hSocket, BYTE mem, int ptr, BYTE len, BYTE *mask, BYTE *IDBuffer, int *nCounter);

//Read a piece of data
apiReturn _stdcall Net_EPC1G2_ReadWordBlock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword);

//Write a piece of data
apiReturn _stdcall Net_EPC1G2_WriteWordBlock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len, BYTE *Data, BYTE *AccessPassword);

//Set read and write protected

apiReturn _stdcall Net_EPC1G2_SetLock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE Lock, BYTE *AccessPassword);

//Tag data erasure
apiReturn _stdcall Net_EPC1G2_EraseBlock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE mem, BYTE ptr, BYTE len);

//Write EPC
apiReturn _stdcall Net_EPC1G2_WriteEPC(SOCKET hSocket,BYTE len, BYTE *Data, BYTE *AccessPassword);

//Block Lock Command
apiReturn _stdcall Net_EPC1G2_BlockLock(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE ptr, BYTE *AccessPassword);

//EAS state operation command
apiReturn _stdcall Net_EPC1G2_ChangeEas(SOCKET hSocket, BYTE EPC_WORD, BYTE *IDBuffer, BYTE State, BYTE *AccessPassword);

//EAS Alarm command
apiReturn _stdcall Net_EPC1G2_EasAlarm(SOCKET hSocket);

//Read protection setting
apiReturn _stdcall Net_EPC1G2_ReadProtect(SOCKET hSocket,BYTE *AccessPassword, BYTE EPC_WORD, BYTE *IDBuffer);

//Reset the read protection setting
apiReturn _stdcall Net_EPC1G2_RStreadProtect(SOCKET hSocket, BYTE *AccessPassword);

//Detection tag 
apiReturn _stdcall Net_EPC1G2_DetectTag(SOCKET hSocket);

//==============================TK900 data read and write commands==============================
//Read the TK900 tag ID number 
apiReturn _stdcall Net_TK900_ReadLabelID(SOCKET hSocket, BYTE *IDBuffer, int *nCounter);

//Reading a piece of data
apiReturn _stdcall Net_TK900_ReadPageBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len,BYTE *Data);

//Write a piece of data
apiReturn _stdcall Net_TK900_WritePageBlock(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE *Data);

//Set the write-prot ect status
apiReturn _stdcall Net_TK900_SetProtect(SOCKET hSocket, BYTE *IDBuffer, BYTE ptr, BYTE len);

//Read and write protected mode
apiReturn _stdcall Net_TK900_GetProtect(SOCKET hSocket, BYTE *IDBuffer ,BYTE *state);

//Settings the label to  enter the TTO stat
apiReturn _stdcall Net_TK900_SetTTO(SOCKET hSocket, BYTE *IDBuffer ,BYTE ptr, BYTE len);

//Read the TTO label
apiReturn _stdcall Net_TK900_ListTagPage(SOCKET hSocket, BYTE *IDBuffer ,BYTE *Data);

//Get the beginning of the address and the length of TTO label
apiReturn _stdcall Net_TK900_GetTTOStartAdd(SOCKET hSocket, BYTE *IDBuffer ,BYTE *len);